﻿local JDI = JDI_2D07EA85_B774_43bf_873C_67DFA1FFDCA1;

JDI.GUI = {};
JDI.GUI.MainFrame = CreateFrame("Frame", nil, UIParent);

local MainFrame = JDI.GUI.MainFrame;

function MainFrame:DoInit()
	local maxwidth, frameheight = 350, 13;
	JDI.GUI.Width = maxwidth;
		
	MainFrame:SetFrameStrata("MEDIUM");
	MainFrame:SetWidth(maxwidth);
	MainFrame:SetAttribute("UIPanelLayout-defined", true);
	MainFrame:SetAttribute("UIPanelLayout-enabled", true);
	MainFrame:SetAttribute("UIPanelLayout-area", "left");
	MainFrame:SetAttribute("UIPanelLayout-pushable", 5);
	MainFrame:SetAttribute("UIPanelLayout-width", maxwidth);
	MainFrame:SetAttribute("UIPanelLayout-whileDead", true);
	MainFrame:SetBackdrop({
			bgFile="Interface\\DialogFrame\\UI-DialogBox-Background",
			edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
			tile = true, tileSize = 32, edgeSize = 32, 
			insets = { left = 8, right = 8, top = 8, bottom = 8 }
		});
	MainFrame:SetBackdropColor(0,0,0,1);
	MainFrame:EnableMouse();
	HideUIPanel(MainFrame);
	MainFrame:SetScript("OnShow", function ()
			MainFrame:DoUpdate();
		end);
	MainFrame:SetScript("OnEvent", MainFrame.EventHandler);
	
	MainFrame.iddTitle = MainFrame:CreateFontString("$parent_Title","ARTWORK","GameFontNormal");
	MainFrame.iddTitle:SetText("Joust Do It! v" .. JDI.JDIVERSION);
	MainFrame.iddTitle:SetPoint("TOPLEFT",MainFrame,"TOPLEFT",13,-frameheight);
	MainFrame.iddTitle:SetWidth(maxwidth - 26);
	MainFrame.iddTitle:SetJustifyH("CENTER");
	
	frameheight = frameheight + MainFrame.iddTitle:GetHeight() + 5;
	
	MainFrame.iddEnableBtn = CreateFrame("Button", nil, MainFrame, "UIPanelButtonTemplate");
	MainFrame.iddEnableBtn:SetText(ENABLE);
	MainFrame.iddEnableBtn:SetPoint("TOPRIGHT",MainFrame,"TOPRIGHT",-13,-frameheight);
	local EnableBtnWidth = MainFrame.iddEnableBtn:GetTextWidth() + 20;
	local BtnHeight = MainFrame.iddEnableBtn:GetTextHeight() + 10;
	MainFrame.iddEnableBtn:SetWidth(EnableBtnWidth);
	MainFrame.iddEnableBtn:SetHeight(BtnHeight);
	MainFrame.iddEnableBtn:SetScript("OnClick", function (self, button)
			if (button == "LeftButton") then
				JDI:SetEnable();
				MainFrame:DoUpdate();
			end
		end)
	
	MainFrame.iddCloseBtn = CreateFrame("Button", nil, MainFrame, "UIPanelCloseButton");
	MainFrame.iddCloseBtn:SetPoint("TOPRIGHT", MainFrame, "TOPRIGHT", -4, -4);
	
	frameheight = frameheight + BtnHeight + 5;
	
	MainFrame.iddOptTarget = CreateFrame("CheckButton", nil, MainFrame, "UICheckButtonTemplate");
	MainFrame.iddOptTarget.iddLabel = MainFrame:CreateFontString("$parent_CheckLabelTarget","ARTWORK","GameFontNormal");
	
	MainFrame.iddOptTarget:SetPoint("TOPLEFT", MainFrame, "TOPLEFT", 13, -frameheight);
	MainFrame.iddOptTarget:SetScript("OnClick", function(self, button)
			if (button == "LeftButton") then
				JDI:SetOptTarget();
				MainFrame:DoUpdate();
			end
		end);
			
	MainFrame.iddOptTarget.iddLabel:SetPoint("TOPLEFT", MainFrame.iddOptTarget, "TOPRIGHT");
	MainFrame.iddOptTarget.iddLabel:SetWidth(maxwidth - 26 - MainFrame.iddOptTarget:GetWidth());
	MainFrame.iddOptTarget.iddLabel:SetText(JDI.Locale.OptTarget);
	MainFrame.iddOptTarget.iddLabel:SetJustifyH("LEFT");
	MainFrame.iddOptTarget.iddLabel:SetJustifyV("MIDDLE");
	if (MainFrame.iddOptTarget.iddLabel:GetHeight() < MainFrame.iddOptTarget:GetHeight()) then
		MainFrame.iddOptTarget.iddLabel:SetHeight(MainFrame.iddOptTarget:GetHeight());
	end
	
	frameheight = frameheight + MainFrame.iddOptTarget.iddLabel:GetHeight() + 5;
	
	MainFrame.iddOptDismount = CreateFrame("CheckButton", nil, MainFrame, "UICheckButtonTemplate");
	MainFrame.iddOptDismount.iddLabel = MainFrame:CreateFontString("$parent_CheckLabelDismount","ARTWORK","GameFontNormal");
	
	MainFrame.iddOptDismount:SetPoint("TOPRIGHT", MainFrame.iddOptTarget.iddLabel, "BOTTOMLEFT");
	MainFrame.iddOptDismount:SetScript("OnClick", function(self, button)
			if (button == "LeftButton") then
				JDI:SetOptDismount();
				MainFrame:DoUpdate();
			end
		end);
			
	MainFrame.iddOptDismount.iddLabel:SetPoint("TOPLEFT", MainFrame.iddOptDismount, "TOPRIGHT");
	MainFrame.iddOptDismount.iddLabel:SetWidth(maxwidth - 26 - MainFrame.iddOptDismount:GetWidth());
	MainFrame.iddOptDismount.iddLabel:SetText(JDI.Locale.OptDismount);
	MainFrame.iddOptDismount.iddLabel:SetJustifyH("LEFT");
	MainFrame.iddOptDismount.iddLabel:SetJustifyV("MIDDLE");
	if (MainFrame.iddOptDismount.iddLabel:GetHeight() < MainFrame.iddOptDismount:GetHeight()) then
		MainFrame.iddOptDismount.iddLabel:SetHeight(MainFrame.iddOptDismount:GetHeight());
	end
	
	frameheight = frameheight + MainFrame.iddOptTarget.iddLabel:GetHeight() + 5;
	
	MainFrame:SetHeight(frameheight + 8);
end

function MainFrame:Toggle()
	if (MainFrame:IsShown()) then
		HideUIPanel(MainFrame);
	else
		ShowUIPanel(MainFrame);
	end
end

function MainFrame:DoUpdate()
	if (JDI.Vars.Enable) then
		MainFrame.iddEnableBtn:SetButtonState("PUSHED", true);
	else
		MainFrame.iddEnableBtn:SetButtonState("NORMAL");
	end
	
	MainFrame.iddOptTarget:SetChecked(JDI.Vars.Target);
	MainFrame.iddOptDismount:SetChecked(JDI.Vars.Dismount);
end

function MainFrame:EventHandler(event, ...)
	if (JDI[event]) then
		JDI[event](self, ...);
	end
end